package org.openqa;
import com.thoughtworks.selenium.DefaultSelenium;
import com.thoughtworks.selenium.SeleneseTestCase;
import com.thoughtworks.selenium.Selenium;

public class LoginTestRefactored extends SeleneseTestCase {
    public void setUp() throws Exception {
        selenium = new DefaultSelenium("localhost", 4444, "*firefox /usr/lib/firefox/firefox-bin", "http://localhost:3000");
        selenium.start();
        selenium.setSpeed("1000");
    }
    
    public void testLoginSuccess() {
        loginHelper("stamat1", "tkzs");
        verifyTrue(selenium.getBodyText().contains("Календар"));
    }
    
    public void testLoginFailed() {
        loginHelper("stamat1", "tkzsasd");
        verifyTrue(selenium.getBodyText().contains("Грешно потребителско име или парола"));
    }
    
    private void loginHelper(String username, String password) {
        selenium.open("/login");
        selenium.type("username", username);
        selenium.type("password", password);
        selenium.click("login");
        selenium.waitForPageToLoad("10000");
    }
}
